<?php

/**
 * This software is intended for use with Oxwall Free Community Software http://www.oxwall.org/ and is
 * licensed under The BSD license.

 * ---
 * Copyright (c) 2011, Oxwall Foundation
 * All rights reserved.

 * Redistribution and use in source and binary forms, with or without modification, are permitted provided that the
 * following conditions are met:
 *
 *  - Redistributions of source code must retain the above copyright notice, this list of conditions and
 *  the following disclaimer.
 *
 *  - Redistributions in binary form must reproduce the above copyright notice, this list of conditions and
 *  the following disclaimer in the documentation and/or other materials provided with the distribution.
 *
 *  - Neither the name of the Oxwall Foundation nor the names of its contributors may be used to endorse or promote products
 *  derived from this software without specific prior written permission.

 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES,
 * INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
 * AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

/**
 * @author Aybat Duyshokov <duyshokov@gmail.com>
 * @package ow_plugins.blogs.components
 * @since 1.0
 */
class BLOGS_CMP_Menu extends OW_Component
{

    public function __construct()
    {
        parent::__construct();
//--
        $item[0] = new BASE_MenuItem();

        $item[0]->setLabel(OW::getLanguage()->text('blogs', 'menuItemLatest'))
            ->setKey('1')
            ->setUrl(OW::getRouter()
                ->urlForRoute('blog-latest'))
            ->setIconClass('ow_ic_clock')
            ->setOrder(1);

        if ( OW::getRequest()->getRequestUri() == OW::getRouter()->uriForRoute('blogs') )
            $item[0]->setActive(true);

//--
        $item[1] = new BASE_MenuItem();

        $item[1]->setLabel(OW::getLanguage()->text('blogs', 'menuItemMostDiscussed'))
            ->setKey('2')
            ->setUrl(OW::getRouter()->urlForRoute('blog-most-discussed'))
            ->setIconClass('ow_ic_comment')
            ->setOrder(3);

//--
        $item[2] = new BASE_MenuItem();

        $item[2]->setLabel(OW::getLanguage()->text('blogs', 'menuItemTopRated'))
            ->setKey('3')
            ->setUrl(OW::getRouter()->urlForRoute('blog-top-rated'))->setIconClass('ow_ic_star')
            ->setOrder(2);
//--
        $item[3] = new BASE_MenuItem();

        $item[3]->setKey('4')
            ->setLabel(OW::getLanguage()->text('blogs', 'menuItemBrowseByTag'))
            ->setOrder(4)
            ->setIconClass('ow_ic_tag')
            ->setUrl(OW::getRouter()->urlForRoute('blog-by-tag'));
//--

        if ( !( false === strstr(OW::getRequest()->getRequestUri(), 'browse-by-tag') ) )
        {
            $item[3]->setActive(true);
        }

        if ( !empty($_GET) )
        {
            $arr = explode('?', OW::getRequest()->getRequestUri());
            switch ( true )
            {
                case in_array($arr[0], array(OW::getRouter()->uriForRoute('blogs'), OW::getRouter()->uriForRoute('blog-latest'))) :
                    $item[0]->setActive(true);
                    break;

                case $arr[0] == OW::getRouter()->uriForRoute('blog-most-discussed'):
                    $item[1]->setActive(true);
                    break;

                case $arr[0] == OW::getRouter()->uriForRoute('blog-top-rated'):
                    $item[2]->setActive(true);
                    break;

                case $arr[0] == OW::getRouter()->uriForRoute('blog-by-tag'):
                    $item[3]->setActive(true);
                    break;
            }
        }

        $this->addComponent('menu', new BASE_CMP_ContentMenu($item));
    }

    public static function getCase()
    {
        switch ( true )
        {
            case ( false !== strpos(OW::getRequest()->getRequestUri(), 'most-discussed') ):

                return 'most-discussed';

            case ( false !== strpos(OW::getRequest()->getRequestUri(), 'top-rated') ):

                return 'top-rated';

            case ( false !== strstr(OW::getRequest()->getRequestUri(), 'browse-by-tag') ):
                return 'browse-by-tag';


            case ( false !== strpos(OW::getRequest()->getRequestUri(), 'latest') ):
                return 'latest';
        }

        return 'latest';
    }
}