<?php

/**
 * EXHIBIT A. Common Public Attribution License Version 1.0
 * The contents of this file are subject to the Common Public Attribution License Version 1.0 (the “License”);
 * you may not use this file except in compliance with the License. You may obtain a copy of the License at
 * http://www.oxwall.org/license. The License is based on the Mozilla Public License Version 1.1
 * but Sections 14 and 15 have been added to cover use of software over a computer network and provide for
 * limited attribution for the Original Developer. In addition, Exhibit A has been modified to be consistent
 * with Exhibit B. Software distributed under the License is distributed on an “AS IS” basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License for the specific language
 * governing rights and limitations under the License. The Original Code is Oxwall software.
 * The Initial Developer of the Original Code is Oxwall Foundation (http://www.oxwall.org/foundation).
 * All portions of the code written by Oxwall Foundation are Copyright (c) 2011. All Rights Reserved.

 * EXHIBIT B. Attribution Information
 * Attribution Copyright Notice: Copyright 2011 Oxwall Foundation. All rights reserved.
 * Attribution Phrase (not exceeding 10 words): Powered by Oxwall community software
 * Attribution URL: http://www.oxwall.org/
 * Graphic Image as provided in the Covered Code.
 * Display of Attribution Information is required in Larger Works which are defined in the CPAL as a work
 * which combines Covered Code or portions thereof with code not governed by the terms of the CPAL.
 */

/**
 * Singleton. 'Flag' Data Access Object
 *
 * @author Aybat Duyshokov <duyshokov@gmail.com>
 * @package ow_system_plugins.base.components
 * @since 1.0
 */
class BASE_CMP_GiveUserRole extends OW_Component
{

    public function __construct()
    {
        parent::__construct('give_user_role');

        $aService = BOL_AuthorizationService::getInstance();

        $list = $aService->findNonGuestRoleList();

        $userId = $_POST['userId'];

        $this->addForm(new GiveRoleForm($list, $userId));

        $this->assign('list', $list);
    }
}

class GiveRoleForm extends Form
{

    public function __construct( $roles, $userId )
    {
        parent::__construct('give-role');

        $this->setAjax(true);

        $this->setAction(OW::getRouter()->urlFor('BASE_CTRL_GiveUserRole', 'give'));

        $hidden = new HiddenField('userId');

        $this->addElement($hidden->setValue($userId));

        $aService = BOL_AuthorizationService::getInstance();

        $uroles = $aService->findUserRoleList($userId);

        $idList = array();

        foreach ( $uroles as $ur )
        {
            $idList[] = $ur->getId();
        }

        foreach ( $roles as $role ) /* @var $role BOL_AuthorizationRole */
        {
            $field = new CheckboxField('roles[' . $role->getId() . ']');
            $field->setLabel(OW::getLanguage()->text('base', 'authorization_role_' . $role->getName()));
            $field->setValue(in_array($role->getId(), $idList));

            $this->addElement($field);
        }

        $this->addElement(new Submit('submit'));

        OW::getDocument()->addOnloadScript(
            "owForms['{$this->getName()}'].bind('success', function(json){
			switch( json['result'] ){
				case 'success':
					var fb = document.storage['role-panel']['fb'];
					fb.close();
					eval(json.js);
					break;
			}
		})");
    }
}